package higa.jhcl.control;

import java.beans.PropertyEditorSupport;

public class BevelEditor extends PropertyEditorSupport {

  private static String[] resourceStrings =
    { "Flat", "Raised", "Lowered", };

  private static int[] intValues = { 0, 1, 2, };
  private static String[] sourceCodeStrings =
    { "0", "1", "2", };

  public BevelEditor() {}

  public String[] getTags() {
    return resourceStrings;
  }

  public String getJavaInitializationString() {
    Object value = getValue();
    for (int i = 0; i < intValues.length; i++) {
      if (value.equals(new Integer(intValues[i]))) {
        return sourceCodeStrings[i];
      }
    }

    return null;
  }

  public String getAsText() {
    Object value = getValue();
    for (int i = 0; i < intValues.length; i++) {
      if (value.equals(new Integer(intValues[i]))) {
        return resourceStrings[i];
      }
    }

    return null;
  }

  public void setAsText(String text)
    throws IllegalArgumentException {

    for (int i = 0; i < resourceStrings.length; i++) {
      if (text.equals(resourceStrings[i])) {
        setValue(new Integer(intValues[i]));
        return;
      }
    }
    
    throw new IllegalArgumentException();
  }
}



