package higa.jhcl.model;

import java.util.EventListener;

public class MatrixModelEvent extends ModelEvent {

  public static final int ITEM_CHANGED =
    CONTENT_CHANGED | 0x0010;

  public static final int ROW_CHANGED =
    CONTENT_CHANGED | 0x0020;

  public static final int COLUMN_CHANGED =
    CONTENT_CHANGED | 0x0030;

  public static final int ROW_ADDED =
    STRUCTURE_CHANGED | 0x0010;

  public static final int ROW_REMOVED =
    STRUCTURE_CHANGED | 0x0020;

  public static final int COLUMN_ADDED =
    STRUCTURE_CHANGED | 0x0030;

  public static final int COLUMN_REMOVED =
    STRUCTURE_CHANGED | 0x0040;

  private MatrixLocation location;

  public MatrixModelEvent(MatrixModel model, int change) {
    super(model, change);
  }

  public MatrixModelEvent(MatrixModel model, int change,
    MatrixLocation location) {

    this(model, change);
    this.location = location;
  }

  public MatrixLocation getLocation() {
    return location;
  }

  public void dispatch(EventListener listener) {
    MatrixModelListener myListener =
      (MatrixModelListener)listener;
      
    switch (getID()) {
      case CONTENT_CHANGED:
        myListener.modelContentChanged(this);
        break;
      case STRUCTURE_CHANGED:
        myListener.modelStructureChanged(this);
        break;
      default:
        throw new IllegalStateException(
          "ID:" + getID());
    }
  }
}