package higa.jhcl.model;

import java.util.EventListener;

import higa.util.BasicEvent;
import higa.util.Dispatch;

public abstract class SelectionEvent
  extends BasicEvent implements Dispatch {

  public static final int ITEM_CHANGE      = 0x0001;
  public static final int RANGE_CHANGE     = 0x0002;
  public static final int SELECTION_CHANGE = 0x0003;

  public static final int ITEM_ADDED =
    ITEM_CHANGE | 0x0010;
    
  public static final int ITEM_REMOVED =
    ITEM_CHANGE | 0x0020;

  public static final int RANGE_ADDED =
    RANGE_CHANGE | 0x0010;
  public static final int RANGE_REMOVED =
    RANGE_CHANGE | 0x0020;

  public static final int SELECTION_CLEARED =
    SELECTION_CHANGE | 0x0010;

  public static final int SELECTION_CHANGED =
    SELECTION_CHANGE | 0x0020;

  private int change;

  public SelectionEvent(Object source, int change) {
    super(source, change & 0x0000F);
    this.change = change;
  }

  public int getChange() {
    return change;
  }
}