package higa.sql.dataset;

import java.util.EventListener;

import higa.util.BasicEvent;
import higa.util.ExceptionDispatch;

public class MasterDataChangeEvent
  extends BasicEvent implements ExceptionDispatch {

  public final static int MASTER_DATA_CHANGED = 0;

  public MasterDataChangeEvent(Object source, int id) {
    super(source, id);
  }

  public void exceptionDispatch(
    EventListener listener) throws Exception {

    MasterDataChangeListener mdcl =
      (MasterDataChangeListener)listener;

    switch (getID()) {
      case MASTER_DATA_CHANGED:
        mdcl.masterDataChanged(this);
        break;
      default:
        throw new IllegalStateException(
          "ID:" + getID());
    }
  }
}