package higa.sql.dataset;

import java.util.EventListener;

import higa.util.BasicEvent;
import higa.util.ExceptionDispatch;

public class TransactionEvent
  extends BasicEvent
  implements ExceptionDispatch {

  public static final int COMMIT = 0;
  public static final int ROLLBACK = 1;

  public TransactionEvent(
    Object source, int id) {

    super(source, id);
  }

  public void exceptionDispatch(
    EventListener listener) throws Exception {
    
    switch (getID()) {
      case COMMIT:
        ((TransactionListener)listener).commit(this);
        break;
      case ROLLBACK:
        ((TransactionListener)listener).rollback(this);
        break;
      default:
        throw new IllegalArgumentException(
          "ID:" + getID());
    }
  }
}