package higa.util;

import java.io.Serializable;

import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

import java.util.EventListener;

public class KeyMulticaster extends EventMulticaster
  implements KeyListener, Serializable {

  public void keyTyped(KeyEvent e) {
    dispatch(e);
  }

  public void keyPressed(KeyEvent e) {
    dispatch(e);
  }

  public void keyReleased(KeyEvent e) {
    dispatch(e);
  }

  public final void dispatch(KeyEvent e) {
    EventListener[] ref = getListeners();

    if (ref != null) {
      int count = ref.length;
      for (int i = 0; i < count; i++) {
        KeyListener listener = (KeyListener)ref[i];
        switch (e.getID()) {
          case KeyEvent.KEY_TYPED:
            listener.keyTyped(e);
            break;
          case KeyEvent.KEY_PRESSED:
            listener.keyPressed(e);
            break;
          case KeyEvent.KEY_RELEASED:
            listener.keyReleased(e);
            break;
        }
      }
    }
  }
}
